/**********************************************************************
 *
 * $Id: write_cache.c,v 1.1 2000/11/01 00:54:26 stevev Exp stevev $
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 **********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <gtk/gtk.h>
#include "read_cache.h"
#include "lists.h"

void write_cache(void)
{
  char *home;
  char buf[512];
  node *current=NULL;
  FILE *fp;
  extern node *mpegListHead;
  int i;

  if ((home = getenv("HOME")) == NULL) {
    fprintf(stderr, "$HOME not defined, cannot write cache.\n");
    return;
  }

  printf("Writing cache files...\n");
  sprintf(buf, "rm -rf %.400s/.mim", home);
  /* check for existing $HOME/.mim (using pathname at buf+7) */
  if (access(buf+7, R_OK|W_OK|X_OK) == 0) {
    /* if it's accessible, clear old cache files */
    strcat(buf, "/cache");
    if (system(buf) != 0) {
      fprintf(stderr, "cannot clear %s/.mim/cache\n", home);
      return;
    }
  }
  else {
    /* if ~/.mim doesn't exist, try to create it */
    if (errno == ENOENT && mkdir(buf+7, 0700) == 0) {
      strcat(buf, "/cache");
    }
    else {
      perror(buf+7);
      return;
    }
  }
  /* (re)create ~/.mim/cache */
  if (mkdir(buf+7, 0700) != 0) {
    perror(buf+7);
    return;
  }

  for (current = mpegListHead, i = 0; current != NULL; current = current->next, i++) {
    sprintf(buf, "%.400s/.mim/cache/%06x", home, i);
    fp = fopen(buf, "w");
    if (fp == NULL) {
      perror(buf);
    }
    else {
      fputs(current->data, fp);
      fclose(fp);
    }
  }
}
